System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Node, Vec3, view, _dec, _dec2, _class, _class2, _descriptor, _temp, _crd, ccclass, property, Script;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      Vec3 = _cc.Vec3;
      view = _cc.view;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "21526VXybhENY6bvOQIscl/", "script", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("Script", Script = (_dec = ccclass('Script'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(Script, _Component);

        function Script() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "sprite", _descriptor, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "touch_id", -1);

          _defineProperty(_assertThisInitialized(_this), "target_position", new Vec3());

          return _this;
        }

        var _proto = Script.prototype;

        _proto.start = function start() {
          this.node.on(Node.EventType.TOUCH_START, this.TouchEvent, this);
          this.node.on(Node.EventType.TOUCH_MOVE, this.TouchEvent, this);
          this.node.on(Node.EventType.TOUCH_END, this.TouchEvent, this);
          this.node.on(Node.EventType.TOUCH_CANCEL, this.TouchEvent, this);
        };

        _proto.TouchEvent = function TouchEvent(e) {
          if (e.type == Node.EventType.TOUCH_START) {
            if (this.touch_id == -1) {
              this.touch_id = e.getID();
              this.target_position = new Vec3(e.getUILocation().x - view.getCanvasSize().x * 0.5, e.getUILocation().y - view.getCanvasSize().y * 0.5, 0);
            }
          }

          if (e.type == Node.EventType.TOUCH_MOVE) {
            if (e.getID() == this.touch_id) {
              this.target_position = new Vec3(e.getUILocation().x - view.getCanvasSize().x * 0.5, e.getUILocation().y - view.getCanvasSize().y * 0.5, 0);
            }
          }

          if (e.type == Node.EventType.TOUCH_END || e.type == Node.EventType.TOUCH_CANCEL) {
            if (e.getID() == this.touch_id) {
              this.touch_id = -1;
              this.target_position = new Vec3();
            }
          }
        };

        _proto.update = function update(deltaTime) {
          if (this.touch_id >= 0) {
            this.sprite.position = Vec3.lerp(new Vec3(), this.sprite.position, this.target_position, deltaTime);
          }
        };

        return Script;
      }(Component), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=script.js.map